;==============================================================================
; Power On Reset Entry Point
;------------------------------------------------------------------------------

; Notes:
;
; This module sets the start of the peripheral registers and then jumps to the
; main control logic.

;==============================================================================
; Revision History:
;
; 2006-01-30 AJ Initial version
;------------------------------------------------------------------------------

                errorlevel -302
                errorlevel -312

                include ../pic.inc
                include ../banks.inc
                include hardware.inc

                global  PowerOnReset
                extern  ControlLogic

PORTA_TRIS      equ     ~((1<<LED_D1)|(1<<LED_D2)|(1<<LED_D3)|(1<<LED_PULSE)|(1<<6))

;==============================================================================

                code

PowerOnReset:
                BANKANY
                BANKABS OPTION_REG
                movlw   (1<<NOT_RBPU)|(1<<PS2)|(1<<PS1)|(1<<PS0)
                movwf   OPTION_REG      ; Set TMR0 prescaler to 1/256

                BANKABS CMCON
                movlw   (1<<CM2)|(1<<CM1)|(1<<CM0)
                movwf   CMCON           ; Select digital I/O on RA0-RA3
                
                BANKABS PORTA   
                clrf    PORTA           ; Clear port values
                clrf    PORTB

                BANKABS TRISA         
                movlw   PORTA_TRIS      ; Select mixed I/O on PORTA
                movwf   TRISA
                clrf    TRISB           ; And all output on PORTB

                BANKABS T1CON
                movlw   (1<<T1CKPS1)|(1<<T1CKPS0)|(1<<TMR1ON)
                movwf   T1CON           ; Configure TIMER1 as timer

                BANKABS T2CON
                movlw   (1<<T2CKPS1)    ; Configure TIMER2 prescaler 1/16
                movwf   T2CON

                lgoto   ControlLogic

                end
