                nolist
;==============================================================================
; Generic PIC Definitions
;------------------------------------------------------------------------------

; Notes:
;
;
; HAS_12_BIT_CORE       - Boolean flag indicating processor architecture
; HAS_14_BIT_CORE       - Boolean flag indicating processor architecture
; HAS_16_BIT_CORE       - Boolean flag indicating processor architecture
;
; HAS_BO_DETECT         - Boolean flag indicating brown out detection
; HAS_INTERRUPTS        - Boolean flag indicating processor
; HAS_SHARED_RAM        - Boolean flag indicating a shared register file area
; HAS_TIMER_8           - The number of 8 bit timers
; HAS_TIMER_16          - The number of 16 bit timers
; HAS_BANKED_RAM        - The number of bits used to select RAM banks (0,1,2)
; HAS_BANKED_CODE       - The number of bits used to select code banks (0,1,2)
; HAS_EEPROM            - Boolean flag indicating built in EEPROM
; HAS_FLASH             - Boolean flag indicating flash code area
;
; HAS_A2D               -
; HAS CCP               -
; HAS_SSP               -
; HAS_MSSP              -
; HAS_USART             -
; HAS_PSP               -
;
; PICKIT_ONE            - Indicates compatibility with PICKit 1
; PICDEM_TWO_PLUS       - Indicates compatibility with PICDEM 2 PLUS

;==============================================================================
; Revision History:
;
; 2005-12-27 AJ Initial version
;------------------------------------------------------------------------------

                page
;==============================================================================
; 12-Bit Cores
;------------------------------------------------------------------------------

                ifdef   __10F200
                include P10F200.inc
                nolist

HAS_12_BIT_CORE equ     1
HAS_TIMER_8     equ     1
                endif

                ifdef   __10F202
                include P10F202.inc
                nolist

HAS_12_BIT_CORE equ     1
HAS_TIMER_8     equ     1
                endif

                ifdef   __10F204
                include P10F204.inc
                nolist

HAS_12_BIT_CORE equ     1
HAS_TIMER_8     equ     1
                endif

                ifdef   __10F206
                include P10F206.inc
                nolist

HAS_12_BIT_CORE equ     1
HAS_TIMER_8     equ     1
                endif

                ifdef   __12C508
                include P12C508.inc
                nolist

HAS_12_BIT_CORE equ     1
                endif

                ifdef   __12C508A
                include P12C508A.inc
                nolist

HAS_12_BIT_CORE equ     1
                endif

                ifdef   __12C509
                include P12C509.inc
                nolist

HAS_12_BIT_CORE equ     1
                endif

                ifdef   __12C509
                include P12C509A.inc
                nolist

HAS_12_BIT_CORE equ     1
                endif

                page
;==============================================================================
; 14-Bit Cores
;------------------------------------------------------------------------------

                ifdef   __12F629
                include P12F629.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_BANKED_RAM  equ     1
HAS_BANKED_CODE equ     0
HAS_EEPROM      equ     1

PICKIT_ONE      equ     1
                endif

                ifdef   __12F675
                include P12F675.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_BANKED_RAM  equ     1
HAS_EEPROM      equ     1

PICKIT_ONE      equ     1
                endif

                ifdef   __16F627A
                include P16F627A.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_BANKED_RAM  equ     2
HAS_EEPROM      equ     1
                endif

                ifdef   __16F628
                include P16F628.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_SHARED_RAM  equ     1
HAS_BANKED_RAM  equ     2
HAS_EEPROM      equ     1
                endif

                ifdef   __16F688
                include P16F688.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_BANKED_RAM  equ     1
HAS_EEPROM      equ     1

PICKIT_ONE      equ     1
                endif


                ifdef   __16F74
                include P16F74.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_BANKED_RAM  equ     1
HAS_BANKED_ROM  equ     1
                endif

                ifdef   __16F873A
                include P16F874A.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_TIMER_8     equ     2
HAS_TIMER_16    equ     1
HAS_BANKED_RAM  equ     2
HAS_BANKED_ROM  equ     1
                endif

                ifdef   __16F874A
                include P16F874A.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_TIMER_8     equ     2
HAS_TIMER_16    equ     1
HAS_BANKED_RAM  equ     2
HAS_BANKED_ROM  equ     1
HAS_EEPROM      equ     1
HAS_FLASH       equ     1
                endif

                ifdef   __16F876A
                include P16F874A.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_TIMER_8     equ     2
HAS_TIMER_16    equ     1
HAS_BANKED_RAM  equ     2
HAS_BANKED_ROM  equ     2
HAS_EEPROM      equ     1
HAS_FLASH       equ     1
                endif

                ifdef   __16F877A
                include P16F877A.inc
                nolist

HAS_14_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_TIMER_8     equ     2
HAS_TIMER_16    equ     1
HAS_BANKED_RAM  equ     2
HAS_BANKED_ROM  equ     2
HAS_EEPROM      equ     1
HAS_FLASH       equ     1
                endif


                page
;==============================================================================
; 16-Bit Cores
;------------------------------------------------------------------------------

                ifdef   __18F4550
                include P18F4550.inc
                nolist

HAS_16_BIT_CORE equ     1
HAS_BO_DETECT   equ     1
HAS_INTERRUPTS  equ     1
HAS_TIMER_8     equ     2
HAS_TIMER_16    equ     1
HAS_BANKED_ROM  equ     2
HAS_EEPROM      equ     1
HAS_FLASH       equ     1
                endif


;==============================================================================
;
;------------------------------------------------------------------------------

                ifndef  HAS_12_BIT_CORE
HAS_12_BIT_CORE equ     0
                endif

                ifndef  HAS_14_BIT_CORE
HAS_14_BIT_CORE equ     0
                endif

                ifndef  HAS_16_BIT_CORE
HAS_16_BIT_CORE equ     0
                endif

                if      !(HAS_12_BIT_CORE|HAS_14_BIT_CORE|HAS_16_BIT_CORE)
                error   "Processor type was not recognized"
                endif

;------------------------------------------------------------------------------

                ifndef  HAS_BO_DETECT
HAS_BO_DETECT   equ     0
                endif

                ifndef  HAS_INTERRUPTS
HAS_INTERRUPTS  equ     0
                endif

;------------------------------------------------------------------------------

                ifndef  HAS_TIMER_16
HAS_TIMER_16    equ     0
                endif

;------------------------------------------------------------------------------

                ifndef  HAS_SHARED_RAM
HAS_SHARED_RAM  equ     0
                endif

                ifndef  HAS_BANKED_RAM
HAS_BANKED_RAM  equ     0
                endif

                ifndef  HAS_BANKED_ROM
HAS_BANKED_ROM  equ     0
                endif

                ifndef  HAS_EEPROM
HAS_EEPROM      equ     0
                endif

                ifndef  HAS_FLASH
HAS_FLASH       equ     0
                endif

;------------------------------------------------------------------------------

                ifndef  HAS_SSP
HAS_SSP         equ     0
                endif

                ifndef  HAS_MSSP
HAS_MSSP        equ     0
                endif

;------------------------------------------------------------------------------

                ifndef  PICKIT_ONE
PICKIT_ONE      equ     0
                endif

                ifndef  PICDEM_TWO_PLUS
PICDEM_TWO_PLUS equ     0
                endif

                list
